// uses a pointer to iterate through an array

#include <iostream>
using namespace std;

int main()
{

  int arr[10] = {99, 35, 87, 99, 0, 7, 6, 23,  2, 700};
  int *iptr1, *iptr2;

  iptr1=arr;  // iptr points to beg of arr
  iptr2=arr+3;
  int i;

  if(iptr1 == iptr2)   // pointer comparison
    cout<<"iptr1 = iptr2"<<endl;

  if (*iptr1 == *iptr2) // arr[0]==arr[3]
    cout<<"now we see that the values of the pointers are the same"<<endl;
  // last stmt of while loop combines these 2 stmts


  cout<< "Loop 1: " << endl;
//use array subscripting
  for (i=0;i<10;i++)
      cout<< "array elt " << i << " :" << arr[i] << endl;

  cout<< "Loop 2: " << endl;
// use indirection
  for (i=0;i<10;i++)
      cout<< "array elt " << i << " :" << *(arr+i) << endl;

  cout<< "Loop 3: " << endl;
// use indirection with iptr
  for (i=0;i<10;i++)
      cout<< "array elt " << i << " :" << *(iptr1+i) << endl;

  cout<< "Loop 4: " << endl;
// use subscripting with iptr

  for (i=0;i<10;i++)
      cout<< "array elt " << i << " :" << iptr1[i] << endl;

cout << "at end of loop i is:" << i << endl;

int numElems;
numElems = sizeof(arr) / sizeof(arr[0]);
cout<<"There are " << numElems<< " items in arr." << endl <<endl;

  cout<< "Loop 5: " << endl;
// use pointer iptr to iterate through the array
  for (iptr1=arr; iptr1<arr+numElems; iptr1++)
      cout<< "array elt " << *iptr1 << endl;

  cout<< "Loop 6: " << endl;
// use pointer iptr to iterate through the array
  for (iptr1=arr; iptr1<=&arr[numElems-1]; iptr1++)
      cout<< "array elt " << *iptr1 << endl;

  return 0;
}





