#ifndef RECTANGLE_H
#define RECTANGLE_H
//#include<iostream>
//using namespace std;

//this file describes the Rectangle class
class Rectangle
{
private:
  double length;
  double width;
  bool isValidDimension(double);
public:
  Rectangle()
  {
    length = 0;
    width = 0;
  }

  Rectangle(double l, double w)
  {
    setLength(l);
    setWidth(w);
  }

  double getLength(){
    return length;
  }
  double getWidth(){
    return width;
  }
  void setLength(double l)
  {
    //input validation in function call
    if (isValidDimension(l))
	length = l;
  }
  void setWidth(double w)
  {
    if (isValidDimension(w))
      width = w;
  }

  double getArea()
  {
    double area = length * width;
    return area;
  }
  Rectangle merge(Rectangle, Rectangle);
};
#endif
