// shows that an array name is an address to the beginning of the array

#include <iostream>
using namespace std;
void  zeroout(int *arr, int n);
void displayarr(const int *arr, int n);

int main()
{

  int number=20;
  int enrollment[20]={1,2,3,4,5,6,7,8,9};

  cout << "size of the array enrollment is: " << sizeof(enrollment) << endl;
  cout << "address of array enrollment is: " << enrollment << endl;

  displayarr(enrollment, number);
  zeroout(enrollment, number);
  displayarr(enrollment, number);

//can have pointer to a const in a function
//can't change the value that the pointer points to
//but you can change the location to which the pointer points to
const int *iptr;
//int  const *  iptr; //same
iptr = &number;
number = 30;
cout<< endl<<" iptr points to the value " << *iptr<<endl;
//*iptr = 40; //error!
int numberOfLetters = 26;
iptr = &numberOfLetters;
cout<< " iptr points to the value " << *iptr<<endl;

//const pointer
//can't change the location to which it points to
//but you can change the value at that location
int * const  iptr2 = &number; //must initialize at definition
cout<< endl<<" iptr2 points to the value " << *iptr2<<endl;
*iptr2 = 40;
cout<< " iptr2 points to the value " << *iptr2<<endl;
//iptr2 = &numberOfLetters; //error!


//can have const pointer to a const:
//can't change the location to which it points to
//can't either change the value at that location
const int * const  iptr3 = &number; //must initialize at definition
cout<< endl<<" iptr3 points to the value " << *iptr3<<endl;
//*iptr3 = 40; //error!
cout<< " iptr3 points to the value " << *iptr3<<endl;
//iptr3 = &numberOfLetters; //error!


  return 0;
}
// an array parameter is the same as accepting a pointer
void  zeroout(int *arr, int n)
{
  cout << "size of the array arr is: " << sizeof(arr) << endl;
  cout << "address of array arr is: " << arr << endl;

// you are allowed to change a pointer variable
 for (int i=0;i<n;i++)
  {
   *arr=0;
   arr++;
  }
}

// accept a pointer to const
// this ensures that the function will NOT modify the values in the array
void displayarr(const int *arr, int n)
{
    cout<<endl<<endl;

 for (int i=0;i<n;i++)
  cout << arr[i] << " ";
 cout << endl;
}


