// pointers to const
// constant pointers

#include <iostream>
using namespace std;

void swap(int *, int *);

int main()
{

  const int SIZE=100;
  int num=1000;

//  SIZE=1000; illegal to assign to a const variable

//  int *ip = &SIZE; illegal to have a regular pointer point to a const

  const int *ip = &SIZE;
  ip = &num;

  // ip is a constant pointer to a constant integer
  // not very useful
  const int * const iptr=&SIZE;


    int num1 =10, num2 = 25;
    int *ptr1 = &num1, *ptr2 = &num2;
    //cout<< " num1 is the value "<< num1<< " and num2 is the value "<< num2<<endl;
    cout<< " first value "<< *ptr1 << " and second value "<< *ptr2<<endl;
    //swap(&num1, &num2);
    //same as
    swap(ptr1, ptr2);
    //cout<< " num1 is the value "<< num1<< " and num2 is the value "<< num2<<endl;
    cout<< " first value "<< *ptr1 << " and second value "<< *ptr2<<endl;
  return 0;
}

void swap(int *x, int *y)
{
    int temp;
    temp = *x;
    *x = *y;
    *y = temp;

}


int* getTotal(int *x, int *y)
{
    /*
    int total;
    int* totalPtr = &total;
    *totalPtr = *x + *y;
    */
    int* totalPtr = x;
    *totalPtr +=5;
    return totalPtr;
}
